=== debian/control ===
Source: recoil
Maintainer: Piotr Fusik <fox@scene.pl>
Section: graphics
Priority: optional
Standards-Version: 3.9.3
Build-Depends: debhelper (>= 7), gcc, libpng12-dev, xsltproc

Package: recoil-2png
Architecture: any
Depends: ${shlibs:Depends}
Description: Provides "recoil2png" command-line converter of pictures
 in native formats of Amiga, Atari 8-bit/Portfolio/ST/Falcon, Commodore 64,
 Macintosh 128K, MSX, SAM Coupe and ZX Spectrum computers.

Package: recoil-thumbnailer
Architecture: all
Depends: recoil-2png
Description: GNOME thumbnailer for pictures in native formats of
 Amiga, Atari 8-bit/Portfolio/ST/Falcon, Commodore 64,
 Macintosh 128K, MSX, SAM Coupe and ZX Spectrum computers.
